<?php
/*
Plugin Name: Feel the comments
Plugin URI: http://sentidoweb.com
Description: Let users to show the kind of feelings they write in their comments using CSS: agree, disagree, love it, wtf, ...
Author: Luis Sacristán
Version: 1.0
Author URI: http://sentidoweb.com
*/

/*  Copyright 2006  LUIS SACRISTÁN PASCUAL  (email : displaynone@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 * 1.0
 *  Version inicial    
 */   



function feel_the_comments_write_plugin_submenu() {
	
	if (isset($_POST["feel_the_comments_form"])) {
		check_admin_referer('feel_the_comments_plugin');
		feel_the_comments_setup_plugin();
	}

	?>
	<style type="text/css">
	 fieldset.submitbox {float: none; width: 100%; border: 0px; margin-bottom: 15px;}
	 fieldset.submitbox span { vertical-align: top;}
	 textarea {width: 300px; height: 250px;}
	 pre {margin-left: 50px; border-left: 2px solid #CCC; padding: 5px; background: #F9F9F9;}
	 label {float: left; display: block; width: 150px;}
	</style>
	<div class="wrap">
		<h2>Feel the Comments</h2>
		<form name="form" method="post">
			<input type="hidden" name="feel_the_comments_form" value="1" />
		  <p>Write what kind of feelings you let users to use, it must be a list of pairs css:text, for example:</p>
		  <pre><code>:How do you feel?
agree:I agree with it
disagre:I disagree with it
loveit:I love it
wft:WTF!!</pre></code>
			<fieldset class="submitbox">
        <label for="feel_the_comments_busqueda">Values</label>
  			<textarea name="feel_the_comments_pairs"><?php echo (get_option("feel_the_comments_pairs") != "")? get_option("feel_the_comments_pairs"): ":How do you feel?\nagree:I agree with this\ndisagre:I disagree with this\nloveit:I love it\nwft:WTF!!"; ?></textarea>
  			<span>Result: </span>
  			<?php feel_the_comments_draw_select(); ?>
			</fieldset>
      <input type="submit" name="Update" value="Save Changes" class="button" />
			<?php wp_nonce_field('feel_the_comments_plugin'); ?>
		</form>
	</div>
	<?php
}

function feel_the_comments_add_plugin_submenu() {
		add_submenu_page('edit.php', 'Feel the Comments', 'Feel the Comments', 1, __FILE__, 'feel_the_comments_write_plugin_submenu');
	add_options_page('Feel the Comments', 'Feel the Comments', 8, 'feel_the_comments.php','feel_the_comments_write_plugin_submenu');		
}	
function feel_the_comments_setup_plugin() {	
	update_option("feel_the_comments_pairs", stripslashes(isset($_POST["feel_the_comments_pairs"])? $_POST["feel_the_comments_pairs"]: ''));
}

function feel_the_comments_draw_select() {
?><select name="feel_the_coments_data"><?php
 if (get_option("feel_the_comments_pairs") != "") {
  $lista = split("\n", get_option("feel_the_comments_pairs"));
  foreach ($lista as $item) {
    $option = split(':', $item);
    if (count($option) == 2) {
      echo '<option value="'.$option[0].'">'.$option[1].'</option>';
    }
  }
 }
?></select><?php
}

$feel_the_comments_class = '';

function feel_the_comments_get_class() {
  global $feel_the_comments_class;
  return $feel_the_comments_class;
}

function feel_the_comments_set_class($class = '') {
  global $feel_the_comments_class;
  $feel_the_comments_class = $class;
}

function feel_the_comments_update_comment ($id) {
  if ($_POST['feel_the_coments_data'] != '') {
  	global $wpdb;
  
  	// First, get all of the original fields
  	$comment = get_comment($id, ARRAY_A);
  	$comment['comment_content'] = '<!--'.$_POST['feel_the_coments_data'].'-->'.$comment['comment_content']; 
  
  	$wpdb->query(
  		"UPDATE $wpdb->comments SET
  			comment_content      = '".$comment['comment_content']."'
  		WHERE comment_ID = $id" );
	}
}

add_action('get_comment_post', 'feel_the_comments_update_comment');

function feel_the_comments_handle_comment($id = '') {
  $comment = get_comment($id, ARRAY_A);
  $comment = $comment['comment_content'];
  preg_match('/^<!\-\-(\w+)\-\->/', $comment, $match);
  if (is_array($match) && count($match) > 1) {
    feel_the_comments_set_class($match[1]);
    return preg_replace('/^<!\-\-(\w+)\-\->/', '', $comment);
  } else {
    feel_the_comments_set_class('');
  }
  return $comment;
}

add_filter('get_comment_ID', 'feel_the_comments_handle_comment');

add_action('admin_menu', 'feel_the_comments_add_plugin_submenu');

?>
